#include "GLObject.h"
#include "GLColor.h"

#ifndef Ball_h
#define Ball_h

class Ball : public GLObject {
public:
    int expTimer; // 爆発アニメーション用のタイマ
	int type; // PLAYER or ENEMY
	int last_type; // 爆発原因 0:壁 1:enemy or player

    Ball(){
        reset();
    }
    
    void reset(){
        GLObject::reset();
        
        type = 0;
        expTimer = -1;
        last_type = 0;
    }

	void setStatus(Ball &ball){
		GLObject::setStatus(ball);

		vec_x = ball.vec_x;
		vec_z = ball.vec_z;
	}
    
    void display(){
        GLObject::display();
        
        if(isExist){
            displayBall();
        }else{
            if(expTimer >= 0 && expTimer < 10){
                displayExp();
                expTimer++;
            }else if(expTimer == 10){
                reset();
            }
        }
    }
    
    // 弾丸みたいな玉を表示する
    void displayBall(){
        glPushMatrix();
        glTranslatef(x, y, z);
        glRotatef(rotate, 0.0, 1.0, 0.0);
        
        glMaterialf(GL_FRONT, GL_AMBIENT, 0.1);
        glMaterialf(GL_FRONT, GL_SPECULAR, 1.0);
        glMaterialf(GL_FRONT, GL_SHININESS, 60);
        
        glMaterialfv(GL_FRONT, GL_DIFFUSE, type==PLAYER ? GLColor::YERROW : GLColor::PURPLE); // 自機 or 敵機で玉の色を変える
        glPushMatrix();
        glTranslatef(0, 0.1, 0);
        glutSolidSphere(0.3, 5, 5);
        glPopMatrix();
        
        glPushMatrix();
        glTranslatef(0, 0.1, 0);
        glRotatef(180, 0, 1, 0);
        glutSolidCone(0.3, 2, 5, 5);
        glPopMatrix();
        
        glPopMatrix();
    }
    
    // 爆発アニメーションを表示する
    void displayExp(){
        glPushMatrix();
        glTranslatef(x, y, z);
        glRotatef(rotate, 0.0, 1.0, 0.0);
        
        glMaterialfv(GL_FRONT, GL_DIFFUSE, last_type ? GLColor::RED : GLColor::GRAY);
        
        glRotatef(expTimer*72, 0, 1, 0);
        // 壁なら灰色，ダメージなら赤色
		glutWireSphere(last_type ? 1+0.015*expTimer*expTimer : 0.5+0.01*expTimer*expTimer, 10, 10);
		//glutSolidSphereはタンクが爆発したときに使うようにする
        glPopMatrix();
    }

};

#endif



