#ifndef GLObject_h
#define GLObject_h

class GLObject {
public:
    float x, y, z; // 座標
    float vec_x, vec_z; // 移動量
	float rotate; // 向き
    bool isExist; // 1なら存在する、0なら画面上にいない
    
    
    GLObject() {
        reset();
    }
    
    void reset(){
        x = y = z = vec_x = vec_z = rotate = 0;
        isExist = false;
    }
    
    // rotate に従って delta だけ前進
    void move(float delta){
        float fR = 360.0 - (rotate + 90.0);
        x += cos(fR * PI / 180.0) * delta;
        z += sin(fR * PI / 180.0) * delta;
    }
    
    void proc(){
    }
    
    void display(){
    }

	void setStatus(GLObject obj){
		x = obj.x;
		y = obj.y;
		z = obj.z;
		rotate = obj.rotate;
		isExist = obj.isExist;
	}
    
    float distance(GLObject p){
        return sqrt((p.x-x)*(p.x-x) + (p.z-z)*(p.z-z));
    }
    
    float direction(GLObject p){
        return atan2(x-p.x, z-p.z) * 180.0/PI;
    }
    
};

#endif

