#include <string>

#include "GLObject.h"
#include "GLColor.h"
#include "uglyfont.h" // http://ysflight.in.coocan.jp/programming/uglyfont/uglyfontj.html

#ifndef Parameter_h
#define Parameter_h

// 画面左上に文字を表示する
class Parameter : public GLObject {
private:
	// 環境依存が激しすぎるので廃止
	// x, yは画面の右下が原点なことに注意
	/*void displayBitmapCharacters(int x, int y, char *string, void *font){
        int len, i;
        glRasterPos2f(x, y);
        len = (int)strlen(string);
        for(i=0; i<len; i++){
            glutBitmapCharacter(font, string[i]);
        }
    }
    void displayText(int x, int y, string str){
		char buff[256];
		strcpy(buff, str.c_str());
		displayText(x, y, buff);
    }

	void displayText(int x, int y, char *str){
        glPushAttrib(GL_ENABLE_BIT);
        glMatrixMode(GL_PROJECTION);
        glPushMatrix();
        glLoadIdentity();
        gluOrtho2D(0, 100, 0, 100);
        glMatrixMode(GL_MODELVIEW);
        glPushMatrix();
        glLoadIdentity();
        glColor3f(0.0, 0.0, 0.0);
        glCallList(list);
        glPopMatrix();
        glMatrixMode(GL_PROJECTION);
        glPopMatrix();
        glPopAttrib();

        glMatrixMode(GL_MODELVIEW);
        list = glGenLists(1);
        glNewList(list, GL_COMPILE);
        
        displayBitmapCharacters(x, y, str, GLUT_BITMAP_TIMES_ROMAN_24);
        glEndList();
	}
	*/
    
public:

    void display(int playerLife, int enemyLife){
        GLObject::display();

		glDisable(GL_LIGHTING); // glColor を有効にする
		glColor3f(0, 0, 0);

		char buff[256];
        sprintf(buff, "playerLife:%d enemyLife:%d level:%d enemySize:%d", playerLife, enemyLife, enemy_level, enemySize);

		glPushMatrix();
		glTranslatef(0,5,-15);
		glScalef(0.8, 1.2, 0.8);
		glRotatef(-60, 1, 0, 0);
		YsDrawUglyFont(buff, 1);
		glPopMatrix();

		if(playerLife == 0 && !AUTOPLAY){
			displayGameOver();
		}

        /*if(enemy_level >= 10){
            sprintf(t, "You won! or continue...?");
            displayText(60, 95, t);
        }*/

		glEnable(GL_LIGHTING);
     }

	void displayGameOver(){
		glPushMatrix();
			glTranslatef(0,1.5,0);
			glScalef(1.8,1.8,1.8);
			glRotatef(-60, 1, 0, 0);
			glColor3f(1, 0, 0);
			YsDrawUglyFont("G A M E  O V E R", 1);
			glTranslatef(0.1, -0.2, 0.1);
			glColor3f(0, 0, 0);
			YsDrawUglyFont("G A M E  O V E R", 1);
			glPopMatrix();

			glPushMatrix();
			glTranslatef(0,1.5,2.5);
			glScalef(1.5,1.5,1.5);
			glRotatef(-60, 1, 0, 0);
			glColor3f(1, 0, 0);
			YsDrawUglyFont("Press r to reset", 1);
			glTranslatef(0.1, -0.2, 0.1);
			glColor3f(0, 0, 0);
			YsDrawUglyFont("Press r to reset", 1);
			glPopMatrix();
	}
};


#endif
